theory Show_Polynomials
  imports 
    "$AFP/Polynomials/Polynomials"
    "$AFP/Show/Show_Instances"
begin
fun shows_monom :: "('v :: show)monom \<Rightarrow> string \<Rightarrow> string" where 
  "shows_monom [(x,p)] = (if p = 1 then shows x else shows x +@+ shows_string ''^'' +@+ shows p)"
| "shows_monom ((x,p) # m) = ((if p = 1 then shows x else shows x +@+ shows_string ''^'' +@+ shows p) +@+ shows_string ''*'' +@+ shows_monom m)"
| "shows_monom [] = shows_string ''1''"

fun shows_poly :: "('v :: show,'a :: {one,show})poly \<Rightarrow> string \<Rightarrow> string" where 
  "shows_poly [] = shows_string ''0''"
| "shows_poly ((m,c) # p) = ((if c = 1 then shows_monom m else if m = [] then shows c else shows c +@+ 
     shows_string ''*'' +@+ shows_monom m) +@+ (if p = [] then shows_string [] else shows_string '' + '' +@+ shows_poly p))"
end